/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 218 by root, Mon Jun 14 12:13:14 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
 rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  
 echo "$name rootfs $rootfs"  
38    
39  # cleanup init scripts which don't work in containers  lxc_rootfs() {
40  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}  }
42  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}  
43    
44    lxc_status() {
45            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                    boot="-"
47                    hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                    ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52    }
53    
54    
55    cleanup_init_scripts() {
56            rootfs=$(lxc_rootfs $1)
57    
58            ls \
59                    $rootfs/etc/rc?.d/*umountfs \
60                    $rootfs/etc/rc?.d/*umountroot \
61                    $rootfs/etc/rc?.d/*hwclock* \
62                    $rootfs/etc/rc?.d/*udev* \
63            2>/dev/null | xargs -i rm -v {}
64    }
65    
66    
67    setup_inittab() {
68            rootfs=$(lxc_rootfs $1)
69            remove=$2
70            add=$3
71    
72            # let container respond to kill -SIGPWR
73            inittab=$rootfs/etc/inittab
74            if ! grep "$add" ${inittab} >/dev/null ; then
75                    grep -v "$remove" ${inittab} > ${inittab}.new
76                    echo $add >> ${inittab}.new
77                    mv ${inittab}.new ${inittab}
78                    echo "$inittab modified with $add"
79            fi
80    }
81    
82    
83    lxc_log() {
84            echo `date +%Y-%m-%dT%H:%M:%S` $*
85    }
86    
87    
88    lxc_kill() {
89            name=$1
90            sig=$2
91    
92            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
93            if [ -z "$init_pid" ] ; then
94                    lxc-info -n $name
95                    exit 1
96            fi
97            lxc_log "$name kill $sig $init_pid"
98            /bin/kill $sig $init_pid
99    }
100    
101    lxc_stop() {
102            lxc_log "$name stop"
103            lxc_kill $name -SIGPWR
104            lxc-wait -n $name -s STOPPED
105            lxc_log "$name stoped"
106    #       rm -f /var/lib/lxc/${name}/on_boot
107    }
108    
109    
110    lxc_start() {
111            name=$1
112    
113            if ! lxc-info -n $name | grep RUNNING ; then
114                    lxc_log "$name start"
115                    lxc-start -n $name -o /tmp/${name}.log -d
116                    lxc-wait  -n $name -s RUNNING
117                    lxc-info  -n $name
118                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
119            fi
120    }
121    
122  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
123    name=$1
124    rootfs=$(lxc_rootfs $1)
125    
126  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
127          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
128          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
129          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          test -z "$tasks" && exit 1
130            if [ "$tasks" -eq 1 ]; then
131    
132                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
133                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
134    
135                  case $runlevel in                  case $runlevel in
136                  N*)                  N*)
137                          # nothing for new boot state                          # nothing for new boot state
138                  ;;                  ;;
139                  ??0)                  ??0)
140                          echo "$name halt"                          lxc_log "$name halt"
141                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
142                            lxc-wait -n ${name} -s STOPPED
143                          break                          break
144                  ;;                  ;;
145                  ??6)                  ??6)
146                          echo "$name reboot";                          lxc_log "$name reboot";
147                          lxc-stop -n ${name}                          lxc-stop -n ${name}
148                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
149                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
150                  ;;                  ;;
151                  *)                  *)
# Line 54  while true; do Line 154  while true; do
154                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
155                  ;;                  ;;
156                  esac                  esac
157            else
158                    lxc_log "$name $tasks tasks"
159          fi          fi
160    
161            # time of 5 minutes on it JUST IN CASE...
162            inotifywait -qqt 300 ${vps_utmp}
163  done  done
164    
165    lxc_log "$name watchdog exited"
166    
167    }
168    
169    
170    usage() {
171            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
172            exit 3
173    }
174    
175    command_on_lxc() {
176    command=$1
177    shift
178    
179    echo "# $command $1"
180    
181    case "$command" in
182    
183    start)
184            lxc_exists $1
185            cleanup_init_scripts $1
186            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
187            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
188            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
189            lxc_start $1
190            # give container 5 seconds to start more than one process
191            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
192            ;;
193    stop|halt)
194            lxc_exists $1
195            lxc_stop $1
196            ;;
197    reload|force-reload|restart|reboot)
198            lxc_kill $1 -SIGINT
199            ;;
200    watchdog)
201            lxc_watchdog $1
202            ;;
203    boot)
204            echo $1 > /var/lib/lxc/$1/on_boot
205            ;;
206    disable)
207            echo -n > /var/lib/lxc/$1/on_boot
208            ;;
209    *)
210            usage
211            ;;
212    
213    esac
214    
215    }
216    
217    command=$1
218    test -z "$command" && usage
219    test "$command" = "status" && lxc_status && exit
220    shift
221    
222    if [ -z "$1" ] ; then
223            ls /var/lib/lxc/*/on_boot | while read path ; do
224                    name=`echo $path | cut -d/ -f5`
225                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
226                            command_on_lxc $command $name
227                    else
228                            echo "# skip $command $name"
229                    fi
230            done
231    else
232            while [ ! -z "$1" ] ; do
233                    command_on_lxc $command $1
234                    shift
235            done
236    fi
237    

Legend:
Removed from v.178  
changed lines
  Added in v.218

  ViewVC Help
Powered by ViewVC 1.1.26